#! /bin/bash
# sudo로 실행 필요

# K8s 설치
# 네트워크 설정
cat << EOF | sudo tee /etc/modules-load.d/k8s.conf
overlay 
br_netfilter
EOF

modprobe overlay
modprobe br_netfilter

cat << EOF | sudo tee /etc/sysctl.d/k8s.conf
net.bridge.bridge-nf-call-iptables  = 1
net.bridge.bridge-nf-call-ip6tables = 1
net.ipv4.ip_forward                 = 1
EOF

sysctl --system

# Containerd config 수정
mkdir -p /etc/containerd
containerd config default | sudo tee /etc/containerd/config.toml
sed  -i 's/ SystemdCgroup = false/ SystemdCgroup = true/' /etc/containerd/config.toml
sudo systemctl restart containerd

# K8s 설치
apt-get update
apt-get install -y apt-transport-https ca-certificates curl
curl -fsSL https://pkgs.k8s.io/core:/stable:/v1.30/deb/Release.key | sudo gpg --dearmor -o /etc/apt/keyrings/kubernetes-apt-keyring.gpg
echo 'deb [signed-by=/etc/apt/keyrings/kubernetes-apt-keyring.gpg] https://pkgs.k8s.io/core:/stable:/v1.30/deb/ /' | sudo tee /etc/apt/sources.list.d/kubernetes.list
apt-get update
apt-get install -y kubelet kubeadm kubectl
apt-mark hold kubelet kubeadm kubectl
echo 'source <(kubectl completion bash)' >> /root/.bashrc
kubectl completion bash >/etc/bash_completion.d/kubectl
